> For the complete documentation index, see [llms.txt](https://developer.electroneum.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developer.electroneum.com/etn-sc-client/interacting-with-etn-sc/json-rpc-namespaces/clique.md).

# clique

The `clique` API provides access to the state of the clique consensus engine. This API can be used to manage signer votes and to check the health of a private network.

### clique\_getSnapshot <a href="#clique-getsnapshot" id="clique-getsnapshot"></a>

Retrieves a snapshot of all clique state at a given block.

| CLIENT  | METHOD INVOCATION                                           |
| ------- | ----------------------------------------------------------- |
| Console | clique.getSnapshot(blockNumber)                             |
| RPC     | {"method": "clique\_getSnapshot", "params": \[blockNumber]} |

Example:

```javascript
> clique.getSnapshot(5463755)
{
  hash: "0x018194fc50ca62d973e2f85cffef1e6811278ffd2040a4460537f8dbec3d5efc",
  number: 5463755,
  recents: {
    5463752: "0x42eb768f2244c8811c63729a21a3569731535f06",
    5463753: "0x6635f83421bf059cd8111f180f0727128685bae4",
    5463754: "0x7ffc57839b00206d1ad20c69a1981b489f772031",
    5463755: "0xb279182d99e65703f0076e4812653aab85fca0f0"
  },
  signers: {
    0x42eb768f2244c8811c63729a21a3569731535f06: {},
    0x6635f83421bf059cd8111f180f0727128685bae4: {},
    0x7ffc57839b00206d1ad20c69a1981b489f772031: {},
    0xb279182d99e65703f0076e4812653aab85fca0f0: {},
    0xd6ae8250b8348c94847280928c79fb3b63ca453e: {},
    0xda35dee8eddeaa556e4c26268463e26fb91ff74f: {},
    0xfc18cbc391de84dbd87db83b20935d3e89f5dd91: {}
  },
  tally: {},
  votes: []
}
```

### clique\_getSnapshotAtHash <a href="#clique-getsnapshotathash" id="clique-getsnapshotathash"></a>

Retrieves the state snapshot at a given block.

| CLIENT  | METHOD INVOCATION                                               |
| ------- | --------------------------------------------------------------- |
| Console | clique.getSnapshotAtHash(blockHash)                             |
| RPC     | {"method": "clique\_getSnapshotAtHash", "params": \[blockHash]} |

### clique\_getSigner <a href="#clique-getsigner" id="clique-getsigner"></a>

Returns the signer for a specific clique block. Can be called with either a blocknumber, blockhash or an rlp encoded blob. The RLP encoded blob can either be a block or a header.

| CLIENT  | METHOD INVOCATION                                    |
| ------- | ---------------------------------------------------- |
| Console | clique.getSigner(blockNrOrHashOrRlp)                 |
| RPC     | {"method": "clique\_getSigner", "params": \[string]} |

### clique\_getSigners <a href="#clique-getsigners" id="clique-getsigners"></a>

Retrieves the list of authorized signers at the specified block number.

| CLIENT  | METHOD INVOCATION                                          |
| ------- | ---------------------------------------------------------- |
| Console | clique.getSigners(blockNumber)                             |
| RPC     | {"method": "clique\_getSigners", "params": \[blockNumber]} |

### clique\_getSignersAtHash <a href="#clique-getsignersathash" id="clique-getsignersathash"></a>

Retrieves the list of authorized signers at the specified block hash.

| CLIENT  | METHOD INVOCATION                                           |
| ------- | ----------------------------------------------------------- |
| Console | clique.getSignersAtHash(blockHash)                          |
| RPC     | {"method": "clique\_getSignersAtHash", "params": \[string]} |

### clique\_proposals <a href="#clique-proposals" id="clique-proposals"></a>

Returns the current proposals the node is voting on.

| CLIENT  | METHOD INVOCATION                              |
| ------- | ---------------------------------------------- |
| Console | clique.proposals()                             |
| RPC     | {"method": "clique\_proposals", "params": \[]} |

### clique\_propose <a href="#clique-propose" id="clique-propose"></a>

Adds a new authorization proposal that the signer will attempt to push through. If the auth parameter is true, the local signer votes for the given address to be included in the set of authorized signers. With auth set to false, the vote is against the address.

| CLIENT  | METHOD INVOCATION                                         |
| ------- | --------------------------------------------------------- |
| Console | clique.propose(address, auth)                             |
| RPC     | {"method": "clique\_propose", "params": \[address, auth]} |

### clique\_discard <a href="#clique-discard" id="clique-discard"></a>

This method drops a currently running proposal. The signer will not cast further votes (either for or against) the address.

| CLIENT  | METHOD INVOCATION                                   |
| ------- | --------------------------------------------------- |
| Console | clique.discard(address)                             |
| RPC     | {"method": "clique\_discard", "params": \[address]} |

### clique\_status <a href="#clique-status" id="clique-status"></a>

This is a debugging method which returns statistics about signer activity for the last 64 blocks. The returned object contains the following fields:

* inturnPercent: percentage of blocks signed in-turn
* sealerActivity: object containing signer addresses and the number of blocks signed by them
* numBlocks: number of blocks analyzed

| CLIENT  | METHOD INVOCATION                           |
| ------- | ------------------------------------------- |
| Console | clique.status()                             |
| RPC     | {"method": "clique\_status", "params": \[]} |

Example:

```javascript
> clique.status()
{
  inturnPercent: 100,
  numBlocks: 64,
  sealerActivity: {
    0x42eb768f2244c8811c63729a21a3569731535f06: 9,
    0x6635f83421bf059cd8111f180f0727128685bae4: 9,
    0x7ffc57839b00206d1ad20c69a1981b489f772031: 9,
    0xb279182d99e65703f0076e4812653aab85fca0f0: 10,
    0xd6ae8250b8348c94847280928c79fb3b63ca453e: 9,
    0xda35dee8eddeaa556e4c26268463e26fb91ff74f: 9,
    0xfc18cbc391de84dbd87db83b20935d3e89f5dd91: 9
  }
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://developer.electroneum.com/etn-sc-client/interacting-with-etn-sc/json-rpc-namespaces/clique.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
